MODULE GDATA
IMPLICIT NONE

Integer,       Parameter     ::  DP    = Kind(1.0D0)
Integer,       PARAMETER     ::  MCENT = 128
Integer,       PARAMETER     ::  MMO=2*512, MPRIMS=4*512, MPTS=400, NTYPE=20
Real(Kind=DP), PARAMETER     ::  BOHR = 0.52917724924_dp
Real(Kind=DP), Parameter     ::  ZERO = 0.0_dp, ONE= 1.0_dp, TWO=2.0_dp, PT5= 0.5_dp


Real(Kind=DP), Parameter :: ISOCO= 2.5_dp ! IsoSurface Cut-off (NanoViz 'restriction')


! UNITS (transformed into parameters; no common block needed)
!Integer, Parameter :: INPT=20, ODX=30, IWFN=10, IDBG=13
!COMMON /UNITS/ INPT,IOUT,IWFN,IDBG


! BTA For the current parameters, (MCENT=100,  MMO=512, MPRIMS=3*512) the max value  for 'S' is:
!--S1 = CEILING(MPRIMS/20.)
!--S2 = CEILING(MPRIMS/5.)
!  WL  = 4 + MCENT + 2*S1 + S2 + MMO*(1+S2) =  158774
!Integer, Parameter :: WL  = 4 + MCENT + 2*S1 + S2 + MMO*(1+S2)
Integer, Parameter :: WL  = 4 + MCENT + MMO + 2*CEILING(MPRIMS/20.0) + (1+MMO)*CEILING(MPRIMS/5.0)


Integer, Parameter :: INPT=20, ODX=30, IDBG=13
Character(Len=81*WL)   :: IWFN  ! But now I have to pass this
COMMON /UNITS/ IWFN


! ZZZZ
Real(Kind=DP), Dimension(MPTS,MMO) :: PSI, GX,GY,GZ, D2
COMMON /ZZZZ/  PSI, GX, GY, GZ, D2


! ATOMS
Real(Kind=DP), DIMENSION(MCENT)      :: XC,YC,ZC, CHARG
Integer                              :: NCENT
COMMON /ATOMS/ XC,YC,ZC,CHARG,NCENT


! STRING
Integer                             :: NAT
CHARACTER(Len=80)                   :: WFNTTL,JOBTTL
CHARACTER(Len=8), DIMENSION(MCENT)  :: ATNAM
COMMON /STRING/ WFNTTL,JOBTTL,ATNAM,NAT


! ORBTL
Integer                       :: NMO
Real(Kind=DP), Dimension(MMO) :: EORB, PO
COMMON /ORBTL/ EORB, PO, NMO

! PRIMS
Integer                              :: NPRIMS
Integer      , DIMENSION(MPRIMS)     :: ICT
Integer      , DIMENSION(NTYPE)      :: ITP
Real(Kind=DP), Dimension(MPRIMS)     :: DIV, EXX, SUM
Real(Kind=DP), Dimension(MPRIMS,MMO) :: COO
COMMON /PRIMS/ DIV, COO, EXX, ICT, SUM, ITP, NPRIMS

! VALUES
Real(Kind=DP)                        :: THRESH1, THRESH2, GAMMA, TOTE
COMMON /VALUES/ THRESH1,THRESH2,GAMMA,TOTE



CONTAINS


Subroutine WTIME( S )
  Implicit NONE
! 24 MAR 07  -BTA-  Timing routine:
! Returns Real (WALL) Time in Seconds (s)

! Dummy argument
 Real(Kind=DP), Intent(OUT) :: S

!Local Variables
Integer :: Count, Count_Rate, Count_Max

!Call SYSTEM_CLOCK(COUNT=Count, Count_Rate, Count_Max)
Call SYSTEM_CLOCK(COUNT=Count, COUNT_RATE=Count_Rate, COUNT_MAX=Count_Max)

 S = Real(Count, Kind=8) / Real(Count_Rate,Kind=8)

End Subroutine WTIME

END MODULE GDATA
