module Rappture
  USE GDATA
  Implicit none  
       
Character(Len=82)  :: STR  ! BTA store a temporary string.     
       
       
Integer,          EXTERNAL :: rp_lib, rp_units_convert_dbl     
Real(Kind=DP),    EXTERNAL :: rp_lib_get_double
Integer,          EXTERNAL :: rp_lib_get_integer ! not implemented in the current OSX lib yet. 
Integer,          EXTERNAL :: rp_lib_get_boolean       
       
Character(Len=82)  :: inFile, StrVal   
Character(Len=82)  :: ILU  ! Internal Logical Unit     
Integer            :: Driver, OK     
character(Len=132) :: xlmpath  

Character(Len=1), Parameter :: endl = char(10) ! New Line      

Character(Len=5) :: sim_id     

CONTAINS

subroutine ID(sid)     
#ifdef IFC
  use IFPORT, ONLY : getPID
#endif
  implicit none
  character(Len=5), Intent(OUT) :: sid 
  integer :: pid
  pid = GetPID()       
  write(ILU,'(I5.5)') pid      
  sid = Trim(ILU)      
end subroutine ID      



subroutine PROGRESS(I,M)
  IMPLICIT NONE

!Dummy Variables:
  Integer, Intent(IN) :: I,M


!Local Variables:
  Integer :: PRGS
  Character(Len=82) :: Message

  PRGS = Int(100*I/M)
  write(ILU,'(I3)') I
  Message  = "Computation in progress....  Layer "//Trim(ILU)//" out of "
  write(ILU,'(I4)') M
  Message  = Trim(Message)//Trim(ILU)
  CALL rp_utils_progress(PRGS, Trim(Message))

end subroutine PROGRESS

end module Rappture   
