PROGRAM CUBEV
  USE RAPPTURE
  USE MACHINE
  IMPLICIT NONE


! 27-JUN-08  -BTA - Rappturized
! 27-JUN-08  -BTA - Translation into F90


! -- CHARACTER(Len=40)  :: OUT,WFN
!
Real(Kind=DP), DIMENSION(3,3)        :: A
Real(Kind=DP), DIMENSION(3)          :: CX, E, CT
Real(Kind=DP), DIMENSION(2)          :: XY
Real(Kind=DP), DIMENSION(3,MCENT)    :: XS, X
Integer,       Dimension(MCENT)      :: IR


Integer :: IFUNC, IEG
Integer :: I,J,k ! counters
Integer :: ios   ! io errors
INTEGER :: EDG   ! Number of points on the cube's edge.

Character(Len=30) :: DATE
Real(Kind=DP) :: start, finish, LcpuT
Real(Kind=DP) :: RT1, RT2,      LwallT


Character(Len=82)    :: FNAME  ! Name of the function (name on the GUI title bar)


!BTA Let's start clocks for bench-marking 
call CPU_TIME(start)  ! CPU
Call WTIME (RT1)      ! WALL


!BTA Initialize RAPPTURE 
CALL Get_Command_Argument(1,inFile) ! BTA f77 GetArg(1,inFile)
driver = rp_lib(inFile)
! BTA 17-MAR-09 : rp_lib is too slow for large data sets. Issue reported to nanoHUB (Derrick)
! call EXIT()


CALL ID(sim_id) ! determine simulation (process) ID
call FDATE(DATE)
STR = 'Job ID: '//sim_id//' started on...   '//Trim(DATE)//endl
Print '(A)', Trim(STR) ! Print message to STDoutput (GUI)
call rp_lib_put_str( driver,                 &
                     "output.log",           &
                      endl//Trim(STR)//endl, &
                     1 )


#ifdef DEBUG
 Write(IDBG,*) "Time spent calling RP_LIB_Put_Str"
 Call WTime(RT2)       ! Wall
 call CPU_TIME(finish) ! CPU
  Lcput = finish
  Lwallt= RT2
 Write(IDBG,500) finish-start
 write(IDBG,600) RT2-RT1
#endif

! Get the WFN
Print '(A)', "Rappture is loading the WFN data into memory...."; Call FLUSH(5)
xlmpath = "input.string(WFN).current"
CALL rp_lib_get(driver, Trim(xlmpath), IWFN)
Print '(A//)', "Preparing to analyze the WFN...."; Call FLUSH(5)

#ifdef DEBUG
Write(IDBG,*) "Time spent calling RP_LIB_GET"
Call WTime(RT2)       ! Wall
call CPU_TIME(finish) ! CPU
Write(IDBG,500) finish-Lcput
write(IDBG,600) RT2-Lwallt
    Lcput = finish
    Lwallt= RT2


Write(IDBG,'(/A)') "WFN string:"
Write(IDBG,'(A)') "Parameters........."
Write(IDBG,'(A,I10)') "MCENT: ",MCENT
Write(IDBG,'(A,I10)') "MPRIMS:",MPRIMS
Write(IDBG,'(A,I10)') "MMO:   ",MMO
Write(IDBG,'(A,I10)') "Max length of WFN string, WL:",WL
write(IDBG,'(A,I10/)') "Len of IWFN (Current space occupied): ",Len_Trim(IWFN)
! Punch  the contents of the WFN string out to a file: check out its structure.
! write(76,*) "Len of IWFN: ",Len_Trim(IWFN)
! write(76,'(A)') Trim(IWFN) ! intel doesn't line this line (gfortran does).
#endif

!WFN = "fort.76"

! OPEN (UNIT=IWFN, FILE=Trim(WFN), IOSTAT=ios)
!if (ios /= 0) then
!   Print*,"Problem reading WFN file"
!   call exit(1)
!endif

!OUT = 
OPEN(UNIT=ODX,  FILE="DX_"//sim_id//".dx", Action='WRITE')
!

!    READ WAVEFUNCTION FILE
!
  Print*, "Reading WFN"; Call FLUSH(5)
  CALL RDPSI
  Print*, "WFN successfully read!!"
  Print '(A//)', "Starting Computation...."; Call FLUSH(5)



!
! INPUT PARAMETERS FOR CUBEV:
! Read Input data from xml

!BTA Title or job ID...
!--- xlmpath = "input.group().integer(NATP).current"
!--- N = rp_lib_get_integer(driver, xlmpath)

!
!    PLOT:   INPUT CUBE EDGE SIZE (IN AU) AND INCREMENT.  THIS
!    EFFECTIVELY DESCIBES THE COARSENESS OF THE CUBE.  THE
!    SAMPLING IS DONE AT (XY(1)/XY(2))**3) POINTS ON AND WITHIN
!    THE CUBE.
!
xlmpath = "input.group(GRID).number(SIZE).current"
XY(1) = rp_lib_get_double(driver, xlmpath)
xlmpath = "input.group(GRID).number(DELTA).current"
XY(2) = rp_lib_get_double(driver, xlmpath)

#ifdef DEBUG
write(IDBG,'(A,2F10.3)') "the Two components XY:", XY
write(IDBG,'(A,I8,A)'),  "Calculating a ",INT(XY(1)/XY(2))**3,"-point cube."
write(IDBG,'(A,I8,A)'),  "A Cube of ",INT(XY(1)/XY(2))," points/edge."
#endif
!
!    CNTR:   DEFINE CENTER OF CUBE
DO i=1,3
   write(ILU,'(I1)') I
!  xlmpath = "input.group(CENTER).number(C"//Trim(ILU)//").current"
   xlmpath = "input.group(CENTER).number(C"//ILU(1:1)//").current"
   CX(I) = rp_lib_get_double(driver, xlmpath)
END DO

CX = -CX ! to be consistent with the displacements on NanoViz coordinates frame.
#ifdef DEBUG
write(IDBG, '(A,3F10.3)') "the Three  components CX:", CX
#endif

EDG = INT(XY(1)/XY(2))
!BTA start building DX file
WRITE(UNIT=ODX,FMT='(A)') "<ODX># BTA - NCN@NU - 2008"
WRITE(ODX,'(A,3I4)')  "object 1 class gridpositions counts", EDG, EDG, EDG
WRITE(ODX,'(A,3F12.6)')  "origin", -XY(1)/2, -XY(1)/2, -XY(1)/2
WRITE(ODX,'(A,3F12.6)')  "delta", XY(2), 0.0,   0.0
WRITE(ODX,'(A,3F12.6)')  "delta", 0.0,   XY(2), 0.0
WRITE(ODX,'(A,3F12.6)')  "delta", 0.0,   0.0,   XY(2)
WRITE(ODX,'(A,3I4)')     "object 2 class gridconnections counts", EDG, EDG, EDG
WRITE(ODX,'(A,I9,1X,A)') "object 3 class array type float rank 0 items", EDG**3,"data follows"
!


!BTA--- For 3D-plot (cubes) 
E=ZERO
CALL EULER(E,A)

!
!    READ IN DESIRED FUNCTION 
xlmpath = "input.group(FUNCTION).choice(FIELD).current"
IFUNC = rp_lib_get_integer(driver, xlmpath)
!
!   CALL ROUTINE TO CALCULATE DESIRED FUNCTION
!
      SELECT CASE(IFUNC)
      CASE(1)
         Print *, "Calculating the molecular electron density map...."
         Print 10, EDG**3
         call flush(5)
         FNAME = "Electron Density ( "//Trim(THEO)//" )"
         CALL CUBRHO (A,CX,XY)

      CASE(2)
         Print *, "Calculating the Laplacian of the Electron density, Del2(Rho) ...."
         Print 10, EDG**3
         call flush(5)
         FNAME = "Laplacian of the Electron Density ( "//Trim(THEO)//" )"
         CALL CUBD2R (A,CX,XY)
         
      CASE(3)
         Print *, "Calculating the Kinetic Energy density, G(r) ...."
         Print 10, EDG**3
         call flush(5)
         FNAME = "Kinetic Energy Density, G(r).  ( "//Trim(THEO)//" )"
         CALL CUBKEG (A,CX,XY,IFUNC)

      CASE(4)
         Print *, "Calculating the Potential Energy density, V(r) ...."
         Print 10, EDG**3
         call flush(5)
         FNAME = "Potential Energy Density, V(r).  ( "//Trim(THEO)//" )"
         CALL CUBKEG (A,CX,XY,IFUNC)

      END SELECT
!
WRITE(ODX,'(A)') 'attribute "element type" string "cubes"'
WRITE(ODX,'(A)') 'attribute "dep" string "positions"'
WRITE(ODX,'(A)') 'object    "regular positions regular connections" class field'
WRITE(ODX,'(A)') 'component "positions" value 1'
WRITE(ODX,'(A)') 'component "connections" value 2'
WRITE(ODX,'(A)') 'component "data" value 3'
CLOSE(ODX)


! Begin <OUTPUT>
! 1.- Molecular Geometry
xlmpath = "output.structure(GEOM).about.label"
STR = "Molecular Geometry ( "//Trim(THEO)//" )"
call rp_lib_put_str(driver, Trim(xlmpath), Trim(STR), 1)
xlmpath = "output.structure(GEOM).about.description"
call rp_lib_put_str(driver, Trim(xlmpath), &
 "The GEOMETRY is defined by the position of the nuclei in the space. &
  The 'bonds' are empirically inferred from the 'atomic radii'.", 1)

do i=1, NCENT
   write(ILU,'(I3)') I
   xlmpath = "output.structure(GEOM).components.molecule.atom("//Trim(ILU)//").symbol"
   write(ILU,'(A4)') ATNam(i)(1:4)
!write(IDBG,*) I, "...",Trim(xlmpath)
!write(IDBG,*) I, "...",Trim(ILU)
   call rp_lib_put_str(driver, Trim(xlmpath), Trim(ILU), 1)
   write(ILU,'(I3)') I
   xlmpath = "output.structure(GEOM).components.molecule.atom("//Trim(ILU)//").xyz"
!write(IDBG,*) I, "...",Trim(xlmpath)
   write(ILU,'(3F12.6)') XC(I)*BOHR, YC(I)*BOHR, ZC(I)*BOHR
!write(IDBG,*) I, "...",Trim(ILU)
   call rp_lib_put_str(driver, Trim(xlmpath), Trim(ILU), 1)
end do

!2.- CUBE:
CALL rp_lib_put_str(driver, "output.field(F3D).about.label",Trim(FNAME),1)
CALL rp_lib_put_str(driver, "output.field(F3D).component.style","-color blue:yellow:red",1)
CALL rp_lib_put_file(driver,"output.field(F3D).component.dx","DX_"//sim_id//".dx",1,1)

!Clean auxiliary files
STR = "rm -fr DX_"//sim_id//".dx"
call system(trim(str))
! end CUBE:

!END <OUTPUT>


!BTA finalize rappture
! Call timing routines and print usage 'CPU' and 'wall' times.
Call WTime(RT2)       ! Wall
call CPU_TIME(finish) ! CPU
print 500, finish-start
print 600, RT2-RT1
call flush(5)


call FDATE(DATE)
STR = endl//'Job ID: '//sim_id//' has successfully finished on: '//Trim(DATE)//endl
call rp_lib_put_str(driver, "output.log", Trim(STR), 1)


STR = Repeat("*",68)//endl//endl
call rp_lib_put_str(driver, "output.log", Trim(STR), 1)


write(ILU,'(A,3x,f8.3,A)') "CPU Time: ",finish," seconds."//endl
call rp_lib_put_str(driver, "output.log", ILU, 1)
write(ILU,'(A,3x,f8.3,A)') "Wall Time:",RT2-RT1," seconds."//endl
call rp_lib_put_str(driver, "output.log", ILU, 1)
STR = Repeat("*",68)//endl
call rp_lib_put_str(driver, "output.log", Trim(STR), 1)

!--Print *, Repeat("bta",100)
!--call flush(5)
!--call sleep(20)

!Rappture-out: 
call rp_result(driver) 



CALL EXIT(0) ! see KILL and ABORT also.


! -BTA-  FORMATS

10 FORMAT("Generating a ",I8," data-point cube.")
500 FORMAT("CPU  Time = ",f6.3," seconds.")
600 FORMAT("REAL Time = ",f6.3," seconds.")

END PROGRAM CUBEV
